<template>
    <div
        ref="mainCont"
        class="list-group"
        style="overflow-y: auto; margin-top:20px;"
    >
        <div class="custom-control custom-switch" style="margin:10px">
            <input 
                type="checkbox" 
                class="custom-control-input" 
                id="customSwitch1"
                :checked="auto_play"
                @change="(e)=>{onAutoPlay(e.target.checked)}"
            >
            <label class="custom-control-label" for="customSwitch1"><h5>auto play</h5></label>
        </div>
        <div 
            v-for="video in reactiv_arr_videos" 
            :key="video.id"
            class="list-group list-group-horizontal"
            style="cursor:pointer;"
            @click="onSelect(video)"
        >
        
        <div 
            class="card"
            :style="`width:${width};`"
        >
            <div class="progress" :style="`width: ${getPercent(video)}%;background: linear-gradient(to top, ${progress_colors[0]}, ${progress_colors[1]},${progress_colors[2]});`">    
            </div>
            <div class="card-body"
                :style="`background-color:${isSelect(video)};padding-top:2px;padding-bottom:2px;color:${text_color};`"
            >
                <div class="row">
                    <div class="d-flex">
                        <h5 class="card-title">{{video.name}}</h5>
                    </div>
                    <div class="d-flex justify-content-end"
                        style="width:100%"
                    >
                        <div class="text-right">
                            <h6 class="card-subtitle mb-2">{{formData.getPreatyTime(video.time)}}</h6>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        </div>
    </div>
</template>

<script>
import videoInfo from '../services/videoInfo';
import formData from '../services/formData';

export default {
    name: 'PlaySheet',
    components: {
        
    },
    props: {
        _select_video:Number,
        arr_videos:Array,
        reactiv_arr_videos:Array,
        control:Object,
        t_color:String,
        height:Number,
        t_main_color:String,
        t_select_color:String,
        t_text_color:String
    },
    data: () => ({
        auto_play:false,
        width:'100%',
        select_video:null,
        formData,
        progress_colors:[
            'rgba(255,255,255,0.6)',
            'rgb(255,255,255)',
            'rgba(255,255,255,0.6)'
        ],
        main_color:'#a0a0a0',
        select_color:'#5755ff',
        text_color:'#ffffffe6'
    }),
    watch:{
        'control.list_orientation':'setHeight',
        'control.height':'setHeight',
        't_main_color':'onMainColor',
        't_select_color':'onSelectColor',
        't_text_color':'onTextColor',
        'arr_videos':'onArrVideos',
        '_select_video':'onSelectVideo'
    },
    mounted(){
        if(this.height && this.control.list_orientation!=='row'){
            this.$refs.mainCont.style['max-height'] = `${this.height}px`;
        }

        if(this.t_color){
            this.color = this.t_color;
        }

        if(this.t_select_color){
            this.select_color = this.t_select_color;
        }

        if(this.t_text_color){
            this.text_color = this.t_text_color;
        }
        //videoInfo.setCurrentVideo(2);
        
        if(!this.arr_videos || this.arr_videos.length<=0){
            return;
        }
        this.onArrVideos();
        
    },
    methods:{
        setHeight(){
            //margin-top: 20px;
            if(this.control.list_orientation==='row'){
                this.$refs.mainCont.style['max-height'] = `${this.control.height}px`;
                this.$refs.mainCont.style['width'] = '33%';
                this.$refs.mainCont.style['margin-top'] = `20px`;
                this.$refs.mainCont.style['margin-left'] = `10px`;
            }else{
                this.$refs.mainCont.style['width'] = `${this.control.width}px`;
                this.$refs.mainCont.style['margin-left'] = `0px`;
            }
            
        },
        onAutoPlay(val){
            videoInfo.setAutoPlay(val);
            this.$emit('onAutoPlay', val);
            //console.log('e = ', e);
        },
        onSelectVideo(){
            //console.log('onSelectVideo!!!!',this._select_video);
            if(this._select_video>=0){
                this.onSelect({idx:this._select_video});
            }
        },
        onArrVideos(){
            if(!Array.isArray(this.arr_videos)){
                return;
            }
            if(this.arr_videos.length<=0){
                this.$emit('initPlayer', {new_arr:[],index:null});
                return;
            }
            this.auto_play = videoInfo.getAutoPlay();
            this.$emit('onAutoPlay', this.auto_play);
            const t_last_video = videoInfo.getCurrentVideo();
            const new_arr = [];
            let last = null;

            this.arr_videos.forEach((v,i)=>{
                let new_v = {... v};
                if(new_v.id==t_last_video){
                    new_v['select'] = true;
                    this.select_video = new_v.id;
                    last = i;
                }else{
                    new_v['select'] = false;
                }
                if(new_v.from===0||new_v.from===null||!new_v.hasOwnProperty('from')){
                    new_v.from = videoInfo.getVideoTime(new_v.id);
                }
                if(!new_v.hasOwnProperty('poster')||new_v.poster===null){
                    new_v['poster'] = false;
                }
                new_v['percent']=0;
                new_v['current_time']=0;
                new_v['playback_rate']=1;
                new_arr.push(new_v);
                //Vue.set(new_arr, i, v);
            });

            if(!last){
                last = 0;
                new_arr[0].select = true;
                this.select_video = new_arr[0].id;
            }
        
            this.$emit('initPlayer', {new_arr,index:last});
        },
        onMainColor(){
            this.main_color = this.t_main_color;
        },
        onSelectColor(){
            this.select_color = this.t_select_color;
        },
        onTextColor(){
            this.text_color = this.t_text_color;
        },
        isSelect({select}){
            if(select){
                return this.select_color;
            }else{
                return this.main_color;
            }
        },

        onSelect({id,idx}){
            let select_v = null;
            let index = null;
            this.reactiv_arr_videos.forEach((v,i)=>{
                if(v.id===id){
                    select_v = v;
                    index = i;
                }
            });

            if(idx && this.reactiv_arr_videos.length>=idx){
                select_v = this.reactiv_arr_videos[idx];
                index = idx;
            }
            //const select_v = this.reactiv_arr_videos.find((v)=>{return v.id===id});
            if(!select_v||select_v===this.select_video){
                return;
            }
            const b_select_v = this.reactiv_arr_videos.find((v)=>{return v.id===this.select_video});
            b_select_v.select = false;
            select_v.select = true;
            videoInfo.setCurrentVideo(select_v.id);
            this.select_video = select_v.id;

            this.$emit('changeVideo', index);
        },

        getPercent({percent,current_time,from,time}){
            if(from<=0){
                return percent;
            }
            return from * 100/ time;
        }
    }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
    .progress{
        z-index:100;
        height:100%;
        width:0%;
        position: absolute; 
        
        opacity:0.7;
    }
    .selected{
        background:olive;
    }
</style>
